/* ibmerror.cmd                                                         */
/* asks for an error number and returns the associated type and message */

say ""
if ARG( 1, e ) then do
	if DATATYPE( ARG( 1 ), "Number" ) \= 1 then do
		say "Usage: IBMERROR [error number]"
		exit 1
	end
	else do
		say "Searching IBM error message database, please wait . . ."
	end
end
else do
	say "Loading IBM error message database into memory, please wait . . ."
end

error. = ""
error.0 = 16540
do i=1 to error.0
        error.i = "* * Sorry, I'm not familiar with this error number * *"
end
do i=100 to 16500 by 100
	error.i = ""
end

error.10 = "Undetermined problem errors"
error.11 = "Undetermined problem error"
error.12 = "Undetermined problem error"
error.13 = "Undetermined problem error"
error.14 = "Undetermined problem error"
error.15 = "Undetermined problem error"
error.16 = "Undetermined problem error"
error.17 = "Undetermined problem error"
error.18 = "Undetermined problem error"
error.19 = "Undetermined problem error"

error.20 = "Power supply errors"
error.21 = "Power supply error"
error.22 = "Power supply error"
error.23 = "Power supply error"
error.24 = "Power supply error"
error.25 = "Power supply error"
error.26 = "Power supply error"
error.27 = "Power supply error"
error.28 = "Power supply error"
error.29 = "Power supply error"

error.100 = "System board errors"
error.101 = "System board error - Interrupt failure"
error.102 = "System board error - Timer failure"
error.103 = "System board error - Timer interrupt failure"
error.104 = "System board error - Protected mode failure"
error.105 = "System board error - Last 8042 command not accepted"
error.106 = "System board error - Converting logic test"
error.107 = "System board error - Hot NMI test"
error.108 = "System board error - Timer bus test"
error.109 = "Direct memory access test error"
error.110 = "System board memory"
error.111 = "Adapter memory"
error.112 = "(any adapter in system unit)"
error.113 = "(any adapter in system unit)"
error.121 = "Unexpected hardware interrupts occurred"
error.131 = "Cassette wrap test failed"
error.151 = "System Board Error; Defective battery"
error.152 = "System Board Error; Real time clock failure"
error.161 = "System Options Error - (Run SETUP) Battery failure"
error.162 = "System options not set correctly-(Run SETUP)"
error.163 = "Time and date not set - (Run SETUP)"
error.164 = "Memory size error - (Run SETUP)"
error.165 = "System options not set - (Run SETUP)"
error.166 = "(any adapter in system unit)"
error.199 = "User-indicated configuration not correct"

error.200 = "Memory (RAM) errors"||"D"x||"A"x||"          (xxyyyy yyzz 201 bad ram chip in bank xx row zz)"
error.201 = "Memory test failed"
error.202 = "Memory address error"
error.203 = "Memory address error"
error.215 = "(system board memory failure)"
error.216 = "(system board memory failure)"

error.300 = "Keyboard errors"
error.301 = "Keyboard did not respond to software reset correctly, or a stuck key"||"D"x||"A"x||"          failure was detected. If a stuck key was detected, the scan code for"||"D"x||"A"x||"          the key is displayed in hexadecimal."
/* For example, the error code 49 301 indicates that Key 73, the PAGE UP key, has failed (49 hex = 73 decimal)" */
error.302 = "User-indicated error from the keyboard test, or AT keylock is locked"
error.303 = "Keyboard or system unit error"
error.304 = "Keyboard or system unit error; CMOS does not match system"
error.305 = "Models 50 and 60 fuse or keyboard cable error"
error.341 = "Replace keyboard"
error.342 = "Replace interface cable"
error.343 = "Replace enhancement card or cable"

error.400 = "Monochrome monitor errors"
error.401 = "Monochrome memory test, horizontal synchronous frequency test,"||"D"x||"A"x||"          or video test failed"
error.408 = "User-indicated display attributes failure"
error.416 = "User-indicated character set failure"
error.424 = "User-indicated 80 X 25 mode failure"
error.432 = "Parallel port test failed (monochrome adapter)"

error.500 = "Color monitor errors"
error.501 = "Color memory test failed, horizontal synchronous frequency test,"||"D"x||"A"x||"          or video test failed"
error.508 = "User-indicated display attribute failure"
error.516 = "User-indicated character set failure"
error.524 = "User-indicated 80 X 25 mode failure"
error.532 = "User-indicated 40 X 25 mode failure"
error.540 = "User-indicated 320 X 200 graphics mode failure"
error.548 = "User-indicated 640 X 200 graphics mode failure"

error.600 = "Diskette drive errors"
error.601 = "Diskette power-on diagnostics test failed"
error.602 = "Diskette test failed; boot record is not valid"
error.603 = "Diskette size error"
error.606 = "Diskette verify function failed"
error.607 = "Write-protected diskette"
error.608 = "Bad command diskette status returned"
error.610 = "Diskette initialization failed"
error.611 = "Timeout - diskette status returned"
error.612 = "Bad NEC (controller) - diskette status returned"
error.613 = "Bad DMA - diskette status returned"
error.614 = "DMA Boundary error"
error.621 = "Bad seek - diskette status returned"
error.622 = "Bad CRC - diskette status returned"
error.623 = "Record not found - diskette status returned"
error.624 = "Bad address mark - diskette status returned"
error.625 = "Bad NEC (controller) seek - diskette status returned"
error.626 = "Diskette data compare error"
error.627 = "Diskette change line error"
error.628 = "Diskette removed"

error.700 = "8087 or 80287 math coprocessor errors"
error.701 = "Math coprocessor test failed"

error.900 = "Parallel printer adapter errors"
error.901 = "Parallel printer adapter test failed"

error.1000 = "Reserved for parallel printer adapter"
error.1001 = "Alt printer Adapter test failed"

error.1100 = "Asynchronous communications adapter errors"
error.1101 = "Asynchronous communications adapter test failed"
error.1102 = "Any serial device (system board)"
error.1106 = "Any serial device (system board)"
error.1107 = "Communications cable (system board)"
error.1108 = "Any serial device (system board)"
error.1109 = "Any serial device (system board)"
error.1110 = "Modem status register not clear"
error.1111 = "Ring indicate failure"
error.1112 = "Trailing edge ring indicate failure"
error.1113 = "Receive and delta receive line signal detect failure"
error.1114 = "Receive line signal detect failure"
error.1115 = "Delta receive line signal detect failure"
error.1116 = "Line control register; all bits cannot be set"
error.1117 = "Line control register; all bits cannot be reset"
error.1118 = "Xmit holding and/or shift register is stuck on"
error.1119 = "Data ready stuck on"
error.1120 = "Interrupt enable register, all bits cannot be set"
error.1121 = "Interrupt enable register, all bits cannot be reset"
error.1122 = "Interrupt pending stuck on"
error.1123 = "Interrupt ID register stuck on"
error.1124 = "Modem control register, all bits cannot be set"
error.1125 = "Modem control register, all bits cannot be reset"
error.1126 = "Modem status register, all bits cannot be set"
error.1127 = "Modem status register, all bits cannot be reset"
error.1128 = "Interrupt ID failure"
error.1129 = "Cannot force overrun error"
error.1130 = "No modem status interrupt"
error.1131 = "Invalid interrupt pending"
error.1132 = "No data ready"
error.1133 = "No data available interrupt"
error.1134 = "No transmit holding interrupt"
error.1135 = "No interrupts"
error.1136 = "No received line status interrupt"
error.1137 = "No receive data available"
error.1138 = "Transmit holding register not empty"
error.1139 = "No modem status interrupt"
error.1140 = "Transmit holding register not empty"
error.1141 = "No interrupts"
error.1142 = "No IRQ4 interrupt"
error.1143 = "No IRQ3 interrupt"
error.1144 = "No data transferred"
error.1145 = "Maximum BAUD rate failed"
error.1146 = "Minimum BAUD rate failed"
error.1148 = "Timeout error"
error.1149 = "Invalid data returned"
error.1150 = "Modem status register error"
error.1151 = "No DSR and Delta DSR"
error.1152 = "No data set ready"
error.1153 = "No delta"
error.1154 = "Modem status register not clear"
error.1155 = "No CTS and Delta CTS"
error.1156 = "No clear to send"
error.1157 = "No delta CTS"

error.1200 = "Alternate asynchronous communications adapter errors"
error.1201 = "Alternate asynchronous communications adapter test failed"
error.1202 = "Dual Asynchronous Adapter/A (Any serial device)"
error.1206 = "Dual Asynchronous Adapter/A (Any serial device)"
error.1207 = "Dual Asynchronous Adapter/A board error"
error.1208 = "Dual Asynchronous Adapter/A (Any serial device)"
error.1209 = "Dual Asynchronous Adapter/A (Any serial device)"

error.1300 = "Game control adapter errors"
error.1301 = "Game control adapter test failed"
error.1302 = "Joystick test failed"

error.1400 = "Printer errors"
error.1401 = "Printer test failed"
error.1404 = "Matrix printer failed"

error.1500 = "Synchronous data link control (SDLC) communications adapter errors"
error.1510 = "8255 Port B failure"
error.1511 = "8255 Port A failure"
error.1512 = "8255 Port C failure"
error.1513 = "8253 Timer 1 did not reach terminal count"
error.1514 = "8253 Timer 1 stuck on"
error.1515 = "8253 Timer 0 did not reach terminal count"
error.1516 = "8253 Timer 0 stuck on"
error.1517 = "8253 Timer 2 did not reach terminal count"
error.1518 = "8253 Timer 2 stuck on"
error.1519 = "8273 Port B error"
error.1520 = "8273 Port A error"
error.1521 = "8273 command/read timeout"
error.1522 = "Interrupt level 4 failure"
error.1523 = "Ring Indicate stuck on"
error.1524 = "Receive clock stuck on"
error.1525 = "Transmit clock stuck on"
error.1526 = "Test indicate stuck on"
error.1527 = "Ring indicate not on"
error.1528 = "Receive clock not on"
error.1529 = "Transmit clock not on"
error.1530 = "Test indicate not on"
error.1531 = "Data set ready not on"
error.1532 = "Carrier detect not on"
error.1533 = "Clear to send not on"
error.1534 = "Data set ready stuck on"
error.1536 = "Clear to send stuck on"
error.1537 = "Level 3 interrupt failure"
error.1538 = "Receive interrupt results error"
error.1539 = "Wrap data miscompare"
error.1540 = "DMA channel 1 error"
error.1541 = "DMA channel 1 error"
error.1542 = "Error in 8273 error checking or status reporting"
error.1547 = "Stray interrupt level 4"
error.1548 = "Stray interrupt level 3"
error.1549 = "Interrupt presentation sequence timeout"

error.1600 = "Display emulation errors (327x, 5520, 525x)"

error.1700 = "Fixed disk errors"
error.1701 = "Fixed Disk/Adapter"
error.1702 = "Time out error"
error.1703 = "Seek error"
error.1704 = "Disk adapter error"
error.1705 = "No record found"
error.1706 = "Write fault error"
error.1707 = "Track 0 error"
error.1708 = "Head select error"
error.1709 = "Defective ECC"
error.1710 = "Read buffer overrun"
error.1711 = "Bad address mark"
error.1712 = "Error-cause not determined"
error.1713 = "Data compare error"
error.1714 = "Drive not ready"
error.1780 = "Disk 0 failure"
error.1781 = "Disk 1 failure"
error.1782 = "Disk adapter error"
error.1790 = "Disk 0 error"
error.1791 = "Disk 1 error"

error.1800 = "I/O expansion unit errors"
error.1801 = "I/O expansion unit POST error"
error.1810 = "Enable/Disable failure"
error.1811 = "Extender card warp test failed (disabled)"
error.1812 = "High order address lines failure (disabled)"
error.1813 = "Wait state failure (disabled)"
error.1814 = "Enable/Disable could not be set on"
error.1815 = "Wait state failure (disabled)"
error.1816 = "Extender card warp test failed (enabled)"
error.1817 = "High order address lines failure (enabled)"
error.1818 = "Disable not functioning"
error.1819 = "Wait request switch not set correctly"
error.1820 = "Receiver card wrap test failure"
error.1821 = "Receiver high order address lines failure"

error.1900 = "3270 PC attachment card errors"

error.2000 = "Binary synchronous communications (BSC) adapter errors"
error.2010 = "8255 Port A failure"
error.2011 = "8255 Port B failure"
error.2012 = "8255 Port C failure"
error.2013 = "8253 Timer 1 did not reach terminal count"
error.2014 = "8253 Timer 1 stuck on"
error.2016 = "8253 Timer 2 did not reach terminal count, or timer 2 stuck on"
error.2017 = "8251 Data set ready failed to come on"
error.2018 = "8251 Clear to send not sensed"
error.2019 = "8251 Data set ready stuck on"
error.2020 = "8251 Clear to send stuck on"
error.2021 = "8251 Hardware reset failed"
error.2022 = "8251 Software reset failed"
error.2023 = "8251 Software "error reset" failed"
error.2024 = "8251 Transmit ready did not come on"
error.2025 = "8251 Receive ready did not come on"
error.2026 = "8251 Could not force "overrun" error status"
error.2027 = "Interrupt failure - no timer interrupt"
error.2028 = "Interrupt failure - transmit, replace card or planar"
error.2029 = "Interrupt failure - transmit, replace card"
error.2030 = "Interrupt failure - receive, replace card or planar"
error.2031 = "Interrupt failure - receive, replace card"
error.2033 = "Ring indicate stuck on"
error.2034 = "Receive clock stuck on"
error.2035 = "Transmit clock stuck on"
error.2036 = "Test indicate stuck on"
error.2037 = "Ring indicate stuck on"
error.2038 = "Receive clock not on"
error.2039 = "Transmit clock not on"
error.2040 = "Test indicate not on"
error.2041 = "Data set ready not on"
error.2042 = "Carrier detect not on"
error.2043 = "Clear to send not on"
error.2044 = "Data set ready stuck on"
error.2045 = "Carrier detect stuck on"
error.2046 = "Clear to send stuck on"
error.2047 = "Unexpected transmit interrupt"
error.2048 = "Unexpected receive interrupt"
error.2049 = "Transmit data did not equal receive data"
error.2050 = "8251 detected overrun error"
error.2051 = "Lost data set ready during data wrap"
error.2052 = "Receive timeout during data wrap"

error.2100 = "Alternate binary synchronous communications adapter errors"
error.2110 = "8255 Port A failure"
error.2111 = "8255 Port B failure"
error.2112 = "8255 Port C failure"
error.2113 = "8253 Timer 1 did not reach terminal count"
error.2114 = "8253 Timer 1 stuck on"
error.2115 = "8253 Timer 2 did not reach terminal count, or timer 2 stuck on"
error.2116 = "8251 Data set ready failed to come on"
error.2117 = "8251 Clear to send not sensed"
error.2118 = "8251 Data set ready stuck on"
error.2119 = "8251 Clear to send stuck on"
error.2120 = "8251 Hardware reset failed"
error.2121 = "8251 Software reset failed"
error.2122 = "8251 Software "error reset" failed"
error.2123 = "8251 Transmit ready did not come on"
error.2124 = "8251 Receive ready did not come on"
error.2125 = "8251 Could not force "overrun" error status"
error.2126 = "Interrupt failure - no timer interrupt"
error.2128 = "Interrupt failure - transmit, replace card or planar"
error.2129 = "Interrupt failure - transmit, replace card"
error.2130 = "Interrupt failure - receive, replace card or planar"
error.2131 = "Interrupt failure - receive, replace card"
error.2133 = "Ring indicate stuck on"
error.2134 = "Receive clock stuck on"
error.2135 = "Transmit clock stuck on"
error.2136 = "Test indicate stuck on"
error.2137 = "Ring indicate stuck on"
error.2138 = "Receive clock not on"
error.2139 = "Transmit clock not on"
error.2140 = "Test indicate not on"
error.2141 = "Data set ready not on"
error.2142 = "Carrier detect not on"
error.2143 = "Clear to send not on"
error.2144 = "Data set ready stuck on"
error.2145 = "Carrier detect stuck on"
error.2146 = "Clear to send stuck on"
error.2147 = "Unexpected transmit interrupt"
error.2148 = "Unexpected receive interrupt"
error.2149 = "Transmit data did not equal receive data"
error.2150 = "8251 detected overrun error"
error.2151 = "Lost data set ready during data wrap"
error.2152 = "Receive timeout during data wrap"

error.2200 = "Cluster adapter errors"

error.2400 = "Enhanced graphics adapter errors"

error.2600 = "XT/370 error codes"

error.2700 = "XT/370 error codes"

error.2900 = "Color matrix printer errors"
error.2901 = "Color matrix printer error"
error.2902 = "Color matrix printer error"
error.2904 = "Color matrix printer error"

error.3000 = "Primary PC Network Adapter Error"
error.3001 = "CPU Failure"
error.3002 = "ROM Failure"
error.3003 = "ID Failure"
error.3004 = "RAM Failure"
error.3005 = "HIC Failure"
error.3006 = "+/- 12v Failed"
error.3007 = "Digital Loopback Failure"
error.3008 = "Host Detected HIC Failure"
error.3009 = "Synchronous Fail & No Go Bit"
error.3010 = "HIC Test OK & No Go Bit"
error.3011 = "Go Bit & No CMD 41"
error.3012 = "Card not present"
error.3013 = "Digital Failure ( Fall Through )"
error.3015 = "Analog Failure"
error.3041 = "Hot Carrier (not this card)"
error.3042 = "Hot Carrier (This Card)"

error.3100 = "Secondary PC Network Adapter Error"
error.3101 = "CPU Failure"
error.3102 = "ROM Failure"
error.3103 = "ID Failure"
error.3104 = "RAM Failure"
error.3105 = "HIC Failure"
error.3106 = "+/- 12v Failed"
error.3107 = "Digital Loopback Failure"
error.3108 = "Host Detected HIC Failure"
error.3109 = "Synchronous Fail & No Go Bit"
error.3110 = "HIC Test OK & No Go Bit"
error.3111 = "Go Bit & No CMD 41"
error.3112 = "Card not present"
error.3113 = "Digital Failure ( Fall Through )"
error.3115 = "Analog Failure"
error.3141 = "Hot Carrier (not this card)"
error.3142 = "Hot Carrier (THIS CARD !!)"

error.3300 = "Compact printer errors"

error.7400 = "Display adapter 8514/A"

error.8500 = "80286 Expanded Memory Adapter/A"
error.8500 = "80286 Expanded Memory Adapter/A"
error.8502 = "80286 Expanded Memory Adapter/A"
error.8503 = "80286 Expanded Memory Adapter/A"
error.8504 = "80286 Expanded Memory Adapter/A"
error.8505 = "80286 Expanded Memory Adapter/A"
error.8506 = "80286 Expanded Memory Adapter/A"
error.8507 = "80286 Expanded Memory Adapter/A"
error.8508 = "80286 Expanded Memory Adapter/A"
error.8509 = "80286 Expanded Memory Adapter/A"
error.8510 = "80286 Expanded Memory Adapter/A"
error.8511 = "80286 Expanded Memory Adapter/A"
error.8512 = "80286 Expanded Memory Adapter/A"
error.8513 = "80286 Expanded Memory Adapter/A"
error.8514 = "80286 Expanded Memory Adapter/A"
error.8515 = "80286 Expanded Memory Adapter/A"
error.8516 = "80286 Expanded Memory Adapter/A"
error.8517 = "80286 Expanded Memory Adapter/A"
error.8518 = "80286 Expanded Memory Adapter/A"
error.8519 = "80286 Expanded Memory Adapter/A"
error.8520 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8521 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8522 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8523 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8524 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8525 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8526 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8527 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8528 = "Memory module package on the 80286 Expanded Memory Adapter/A"
error.8529 = "Memory module package on the 80286 Expanded Memory Adapter/A"

error.8600 = "PS/2 pointing device errors"
error.8601 = "Pointing device (IBM mouse)"
error.8602 = "Pointing device"
error.8603 = "System board error"
error.8604 = "System board : Pointing device"

error.10000 = "Multiprotocol Adapter/A"
error.10002 = "Multiprotocol Adapter/A any serial device"
error.10006 = "Multiprotocol Adapter/A any serial device"
error.10007 = "Communications cable Multiprotocol Adapter/A"
error.10008 = "Multiprotocol Adapter/A any serial device"
error.10009 = "Multiprotocol Adapter/A any serial device"

error.10100 = "Modem Adapter/A"
error.10102 = "Modem Adapter/A any serial device"
error.10106 = "Modem Adapter/A any serial device"
error.10108 = "Modem Adapter/A any serial device"
error.10109 = "Modem Adapter/A any serial device"

error.10400 = "Fixed disk adapter (ESDI) drives 0 or 1 (C or D)"
error.10480 = "Fixed disk C, adapter (ESDI) or system board error"
error.10481 = "Fixed disk D, adapter (ESDI) or system board error"
error.10482 = "Fixed disk C or system board error"
error.10483 = "Fixed disk adapter (ESDI) or system board error"
error.10490 = "Fixed disk C or adapter (ESDI) error"
error.10491 = "Fixed disk C or adapter (ESDI) error"

error.16500  = "6157 Tape Attachment Adapter"
error.16520  = "6157 Streaming Tape Drive"
error.16540  = "6157 Streaming Tape Drive or tape attachment adapter"

say "[1A[K[1A"

if ARG( 1, e ) then do
	number = ARG( 1 )
	number = FORMAT( number )
        type = 100 * trunc( number / 100 )
	if type = 0 then do
		type = 10
		if number > 19 & number < 30 then type = 20
	end
	if error.type = "" then do
		say "Type    : * * Sorry, unknown error type * *"
	end
	else do
	        say "Type    : "||error.type
	        if number \= type then say "Message : "||error.number
	end
        say ""
end
else do forever
        say "Enter an error number (or press Return to quit):"
        pull number
        if number = "" then leave
	if DATATYPE( number, "Number" ) \= 1 then do
		say "Enter error NUMBERS only"||"7"X
	end
	else do
		number = FORMAT( number )
		type = 100 * trunc( number / 100 )
		if type = 0 then do
			type = 10
			if number > 19 & number < 30 then type = 20
		end
		if error.type = "" then do
			say "Type    : * * Sorry, unknown error type * *"
		end
		else do
		        say "Type    : "||error.type
        		if number \= type then say "Message : "||error.number
		end
	end
        say ""
end
